<script setup lang="ts">
  import { CmsSlot } from '@shopware-pwa/types';
  import { getCmsLayoutConfiguration } from '@shopware-pwa/helpers-next';
  import { resolveCmsComponent } from '@shopware-pwa/composables-next';
  import SwTarget from '~/components/shared/organisms/SwTarget.vue';
  import { CmsSlotKey, CmsPageKey } from '~/helpers/injection';

  const props = defineProps<{
    content: CmsSlot;
  }>();

  provide(CmsSlotKey, {
    elementId: props.content.customFields?._uniqueIdentifier as string,
  });

  const cmsPageInject = inject(CmsPageKey);

  const { publishScrollTo, publishHoverStart, publishHoverEnd, publishHover } =
    useElementInteraction();

  const DynamicRender = () => {
    const { resolvedComponent, componentName, isResolved } = resolveCmsComponent(props.content);

    if (resolvedComponent) {
      if (!isResolved) return h('div', {}, 'Problem resolving component: ' + componentName);

      const { cssClasses, layoutStyles } = getCmsLayoutConfiguration(props.content);
      const canBeTarget = !['product-listing', 'like'].includes(componentName);
      const id = props.content.customFields?._uniqueIdentifier as string;
      if (!canBeTarget) {
        return h(
          'div',
          {
            id,
            name: `cms-element-${componentName}`,
            style: layoutStyles,
            class: cssClasses,
          },
          h(resolvedComponent, {
            content: props.content,
          }),
        );
      } else {
        return h(
          'div',
          {
            id,
            name: `cms-element-${componentName}`,
            class: [cssClasses, 'transition flex flex-col relative'],
            style: layoutStyles,
            onTouchstart: () => publishHoverStart(id),
            onTouchend: () => publishHoverEnd(),
            onMouseenter: () => publishHoverStart(id),
            onMouseleave: () => publishHoverEnd(),
            onClick: () => publishHover(id),
          },
          cmsPageInject?.type === 'presentation'
            ? h(
                SwTarget,
                {
                  onPublish: () => publishScrollTo(id),
                },
                () =>
                  h(resolvedComponent, {
                    content: props.content,
                  }),
              )
            : h(resolvedComponent, {
                content: props.content,
              }),
        );
      }
    }
    return h('div', {}, 'Loading...');
  };
</script>

<template>
  <DynamicRender />
</template>
